--[[
	PowerUp - Warlock Module
]]
local _, PowerUp = ...

if PowerUp.class ~= "WARLOCK" then return end

local db
local powerType, powerName

-- Setup frames
function PowerUp:Init()
	db = PowerUpDB
	db.max = 3
	
	powerType = "SOUL_SHARDS"
	powerName = SPELL_POWER_SOUL_SHARDS
	
	self:Workshop()
	self:Paintshop()
	
	self:RegisterEvent("UNIT_POWER")
	self.UNIT_POWER = self.RefreshPowers
	
	-- update powers at login/zoning in case we have some already
	-- if a power disappears during loading screen, it wont update 
	-- properly otherwise.
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function PowerUp:PLAYER_ENTERING_WORLD()
	self:RefreshPowers("player", powerType)
end

function PowerUp:RefreshPowers(unit, power)
	if unit ~= "player" or (power and power ~= powerType) then return end
	local num = UnitPower("player", powerName)
	
	if db.hidewhenempty and num == 0 then
		self.frame:Hide()
	else
		self.frame:Show()
	end
	
	for i = 1, db.max do
		if(i <= num) then
			self.bars[i]:SetAlpha(1)
		else
			self.bars[i]:SetAlpha(0)
		end
	end
end